Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -2422,420 +2616,407 @@
   Int**      m_depthToDisparityB; 
   Int**      m_depthToDisparityF; 
-#endif
-#endif
-  Bool      m_bApplyDIS;
+  Bool       m_bApplyDIS;
+#endif
+#endif
 #if H_3D_IC
-  Int*      m_aICEnableCandidate;
-  Int*      m_aICEnableNum;
-#endif
-  Int       m_iDefaultRefViewIdx;
-  Bool      m_bDefaultRefViewIdxAvailableFlag;
-
-  Bool m_ivMvPredFlag         ;
-  Bool m_ivMvScalingFlag      ;
-  Bool m_ivResPredFlag        ;
-  Bool m_depthRefinementFlag  ;
-  Bool m_viewSynthesisPredFlag;
-  Bool m_depthBasedBlkPartFlag;
-  Bool m_mpiFlag              ;
-  Bool m_intraContourFlag     ;
-  Bool m_intraSdcWedgeFlag    ;
-  Bool m_qtPredFlag           ;
-  Bool m_interSdcFlag         ;
-  Bool m_depthIntraSkipFlag   ;
-  Int  m_mpiSubPbSize         ; 
-  Int  m_subPbSize            ; 
+  Int*       m_aICEnableCandidate;
+  Int*       m_aICEnableNum;
+#endif       
+#if NH_3D   
+  Int        m_iDefaultRefViewIdx;
+  Bool       m_bDefaultRefViewIdxAvailableFlag;
+             
+  Bool       m_ivMvPredFlag         ;
+  Bool       m_ivMvScalingFlag      ;
+  Bool       m_ivResPredFlag        ;
+  Bool       m_depthRefinementFlag  ;
+  Bool       m_viewSynthesisPredFlag;
+  Bool       m_depthBasedBlkPartFlag;
+  Bool       m_mpiFlag              ;
+  Bool       m_intraContourFlag     ;
+  Bool       m_intraSdcWedgeFlag    ;
+  Bool       m_qtPredFlag           ;
+  Bool       m_interSdcFlag         ;
+  Bool       m_depthIntraSkipFlag   ;
+  Int        m_mpiSubPbSize         ; 
+  Int        m_subPbSize            ; 
+#endif
 public:
-  TComSlice();
-  virtual ~TComSlice(); 
-  Void      initSlice       ();
-
-  Void      setVPS          ( TComVPS* pcVPS ) { m_pcVPS = pcVPS; }
-  TComVPS*  getVPS          () { return m_pcVPS; }
-  Void      setSPS          ( TComSPS* pcSPS ) { m_pcSPS = pcSPS; }
-  TComSPS*  getSPS          () { return m_pcSPS; }
-  
-  Void      setPPS          ( TComPPS* pcPPS )         { assert(pcPPS!=NULL); m_pcPPS = pcPPS; m_iPPSId = pcPPS->getPPSId(); }
-  TComPPS*  getPPS          () { return m_pcPPS; }
-
+                              TComSlice();
+  virtual                     ~TComSlice();
+  Void                        initSlice();
+
+  Void                        setVPS( TComVPS* pcVPS )                               { m_pcVPS = pcVPS;                                              }
+  const TComVPS*              getVPS() const                                         { return m_pcVPS;                                               }
+  Void                        setSPS( const TComSPS* pcSPS )                         { m_pcSPS = pcSPS;                                              }
+  const TComSPS*              getSPS() const                                         { return m_pcSPS;                                               }
+
+  Void                        setPPS( const TComPPS* pcPPS )                         { m_pcPPS = pcPPS; m_iPPSId = (pcPPS) ? pcPPS->getPPSId() : -1; }
+  const TComPPS*              getPPS() const                                         { return m_pcPPS;                                               }
+
+  Void                        setPPSId( Int PPSId )                                  { m_iPPSId = PPSId;                                             }
+  Int                         getPPSId() const                                       { return m_iPPSId;                                              }
+  Void                        setPicOutputFlag( Bool b   )                           { m_PicOutputFlag = b;                                          }
+#if NH_MV
+  Void                        setSlicePicOrderCntLsb( Int i )                        { m_slicePicOrderCntLsb = i;                                    }
+  Int                         getSlicePicOrderCntLsb(  )  const                      { return m_slicePicOrderCntLsb;                                 }
+#endif
+  Bool                        getPicOutputFlag() const                               { return m_PicOutputFlag;                                       }
+  Void                        setSaoEnabledFlag(ChannelType chType, Bool s)          {m_saoEnabledFlag[chType] =s;                                   }
+  Bool                        getSaoEnabledFlag(ChannelType chType) const            { return m_saoEnabledFlag[chType];                              }
+  Void                        setRPS( TComReferencePictureSet *pcRPS )               { m_pcRPS = pcRPS;                                              }
+  TComReferencePictureSet*    getRPS()                                               { return m_pcRPS;                                               }
+  TComReferencePictureSet*    getLocalRPS()                                          { return &m_LocalRPS;                                           }
+
+  Void                        setRPSidx( Int iBDidx )                                { m_iBDidx = iBDidx;                                            }
+  Int                         getRPSidx() const                                      { return m_iBDidx;                                              }
+  TComRefPicListModification* getRefPicListModification()                            { return &m_RefPicListModification;                             }
+  Void                        setLastIDR(Int iIDRPOC)                                { m_iLastIDR = iIDRPOC;                                         }
+  Int                         getLastIDR() const                                     { return m_iLastIDR;                                            }
+  Void                        setAssociatedIRAPPOC(Int iAssociatedIRAPPOC)           { m_iAssociatedIRAP = iAssociatedIRAPPOC;                       }
+  Int                         getAssociatedIRAPPOC() const                           { return m_iAssociatedIRAP;                                     }
+  Void                        setAssociatedIRAPType(NalUnitType associatedIRAPType)  { m_iAssociatedIRAPType = associatedIRAPType;                   }
+  NalUnitType                 getAssociatedIRAPType() const                          { return m_iAssociatedIRAPType;                                 }
+  SliceType                   getSliceType() const                                   { return m_eSliceType;                                          }
+  Int                         getPOC() const                                         { return m_iPOC;                                                }
+  Int                         getSliceQp() const                                     { return m_iSliceQp;                                            }
+  Bool                        getDependentSliceSegmentFlag() const                   { return m_dependentSliceSegmentFlag;                           }
+  Void                        setDependentSliceSegmentFlag(Bool val)                 { m_dependentSliceSegmentFlag = val;                            }
 #if ADAPTIVE_QP_SELECTION
-  Void          setTrQuant          ( TComTrQuant* pcTrQuant ) { m_pcTrQuant = pcTrQuant; }
-  TComTrQuant*  getTrQuant          () { return m_pcTrQuant; }
-#endif
-
-  Void      setPPSId        ( Int PPSId )         { m_iPPSId = PPSId; }
-  Int       getPPSId        () { return m_iPPSId; }
-  Void      setPicOutputFlag( Bool b )         { m_PicOutputFlag = b;    }
-  Bool      getPicOutputFlag()                 { return m_PicOutputFlag; }
-#if H_MV
-  Void      setSlicePicOrderCntLsb( Int i ) { m_slicePicOrderCntLsb = i; }; 
-  Int       getSlicePicOrderCntLsb(  )      { return m_slicePicOrderCntLsb; }; 
-#endif
-  Void      setSaoEnabledFlag(Bool s) {m_saoEnabledFlag =s; }
-  Bool      getSaoEnabledFlag() { return m_saoEnabledFlag; }
-  Void      setSaoEnabledFlagChroma(Bool s) {m_saoEnabledFlagChroma =s; }       //!< set SAO Cb&Cr enabled flag
-  Bool      getSaoEnabledFlagChroma() { return m_saoEnabledFlagChroma; }        //!< get SAO Cb&Cr enabled flag
-  Void      setRPS          ( TComReferencePictureSet *pcRPS ) { m_pcRPS = pcRPS; }
-  TComReferencePictureSet*  getRPS          () { return m_pcRPS; }
-  TComReferencePictureSet*  getLocalRPS     () { return &m_LocalRPS; }
-
-  Void      setRPSidx          ( Int iBDidx ) { m_iBDidx = iBDidx; }
-  Int       getRPSidx          () { return m_iBDidx; }
-  Int       getPrevTid0POC      ()                        { return  m_prevTid0POC;       }
-  TComRefPicListModification* getRefPicListModification() { return &m_RefPicListModification; }
-  Void      setLastIDR(Int iIDRPOC)                       { m_iLastIDR = iIDRPOC; }
-  Int       getLastIDR()                                  { return m_iLastIDR; }
-  Void      setAssociatedIRAPPOC(Int iAssociatedIRAPPOC)             { m_iAssociatedIRAP = iAssociatedIRAPPOC; }
-  Int       getAssociatedIRAPPOC()                        { return m_iAssociatedIRAP; }
-  Void      setAssociatedIRAPType(NalUnitType associatedIRAPType)    { m_iAssociatedIRAPType = associatedIRAPType; }
-  NalUnitType getAssociatedIRAPType()                        { return m_iAssociatedIRAPType; }
-  SliceType getSliceType    ()                          { return  m_eSliceType;         }
-  Int       getPOC          ()                          { return  m_iPOC;           }
-  Int       getSliceQp      ()                          { return  m_iSliceQp;           }
-  Bool      getDependentSliceSegmentFlag() const        { return m_dependentSliceSegmentFlag; }
-  void      setDependentSliceSegmentFlag(Bool val)      { m_dependentSliceSegmentFlag = val; }
+  Int                         getSliceQpBase() const                                 { return m_iSliceQpBase;                                        }
+#endif
+  Int                         getSliceQpDelta() const                                { return m_iSliceQpDelta;                                       }
+  Int                         getSliceChromaQpDelta(ComponentID compID) const        { return isLuma(compID) ? 0 : m_iSliceChromaQpDelta[compID];    }
+  Bool                        getUseChromaQpAdj() const                              { return m_ChromaQpAdjEnabled;                                  }
+  Bool                        getDeblockingFilterDisable() const                     { return m_deblockingFilterDisable;                             }
+  Bool                        getDeblockingFilterOverrideFlag() const                { return m_deblockingFilterOverrideFlag;                        }
+  Int                         getDeblockingFilterBetaOffsetDiv2()const               { return m_deblockingFilterBetaOffsetDiv2;                      }
+  Int                         getDeblockingFilterTcOffsetDiv2() const                { return m_deblockingFilterTcOffsetDiv2;                        }
+
+  Int                         getNumRefIdx( RefPicList e ) const                     { return m_aiNumRefIdx[e];                                      }
+  TComPic*                    getPic()                                               { return m_pcPic;                                               }
+  TComPic*                    getRefPic( RefPicList e, Int iRefIdx)                  { return m_apcRefPicList[e][iRefIdx];                           }
+  Int                         getRefPOC( RefPicList e, Int iRefIdx)                  { return m_aiRefPOCList[e][iRefIdx];                            }
+#if NH_3D
+  Bool                        getInCmpPredAvailFlag( )                 const         { return m_inCmpPredAvailFlag;                                  }
+  Bool                        getCpAvailableFlag( )                    const         { return m_cpAvailableFlag;                                     }
+  Bool                        getInCompPredFlag( )                     const         { return m_inCmpPredFlag;                                       }
+  Void                        setInCompPredFlag( Bool b )                            { m_inCmpPredFlag = b;                                          }
+  Int                         getInCmpRefViewIdcs( Int i )             const         { return m_inCmpRefViewIdcs  [i];                               }
+  Int                         getNumCurCmpLIds( )                      const         { return (Int) m_inCmpRefViewIdcs.size();                       }
+  TComPic*                    getIvPic( Bool depthFlag, Int viewIndex) const         { return  m_ivPicsCurrPoc[ depthFlag ? 1 : 0 ][ viewIndex ];    }
+#endif                                                                                                                                               
+#if H_3D                                                                                                                                             
+  TComPic*                    getTexturePic       ()                                 { return  m_ivPicsCurrPoc[0][ m_viewIndex ];                    }
+#endif                                                                                                                                               
+#if H_3D_IC                                                                                                                                          
+  Void                        setApplyIC( Bool b )                                   { m_bApplyIC = b;                                               }
+  Bool                        getApplyIC()                                           { return m_bApplyIC;                                            }
+  Void                        xSetApplyIC();                                                                                                         
+  Void                        xSetApplyIC(Bool bUseLowLatencyICEnc);                                                                                 
+  Void                        setIcSkipParseFlag( Bool b )                           { m_icSkipParseFlag = b;                                        }
+  Bool                        getIcSkipParseFlag()                                   { return m_icSkipParseFlag;                                     }
+#endif                                                                                                                                               
+#if H_3D_ARP                                                                                                                                         
+  Void                        setBaseViewRefPicList( TComList<TComPic*> *pListPic, Int iViewIdx )      { m_pBaseViewRefPicList[iViewIdx] = pListPic; }                  
+  Void                        setARPStepNum( TComPicLists*ivPicLists );                                                                              
+  TComPic*                    getBaseViewRefPic    ( UInt uiPOC , Int iViewIdx )     { return xGetRefPic( *m_pBaseViewRefPicList[iViewIdx], uiPOC ); }
+  UInt                        getARPStepNum( )                                       { return m_nARPStepNum;                                         }  
+#endif
+  Int                         getDepth() const                                       { return m_iDepth;                                              }
+  Bool                        getColFromL0Flag() const                               { return m_colFromL0Flag;                                       }
+  UInt                        getColRefIdx() const                                   { return m_colRefIdx;                                           }
+  Void                        checkColRefIdx(UInt curSliceIdx, TComPic* pic);
+  Bool                        getIsUsedAsLongTerm(Int i, Int j) const                { return m_bIsUsedAsLongTerm[i][j];                             }
+  Void                        setIsUsedAsLongTerm(Int i, Int j, Bool value)          { m_bIsUsedAsLongTerm[i][j] = value;                            }
+  Bool                        getCheckLDC() const                                    { return m_bCheckLDC;                                           }
+  Bool                        getMvdL1ZeroFlag() const                               { return m_bLMvdL1Zero;                                         }
+  Int                         getNumRpsCurrTempList() const;
+  Int                         getList1IdxToList0Idx( Int list1Idx ) const            { return m_list1IdxToList0Idx[list1Idx];                        }
+  Void                        setReferenced(Bool b)                                  { m_bRefenced = b;                                              }
+  Bool                        isReferenced() const                                   { return m_bRefenced;                                           }
+  Bool                        isReferenceNalu() const                                { return ((getNalUnitType() <= NAL_UNIT_RESERVED_VCL_R15) && (getNalUnitType()%2 != 0)) || ((getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP) && (getNalUnitType() <= NAL_UNIT_RESERVED_IRAP_VCL23) ); }
+  Void                        setPOC( Int i )                                        { m_iPOC              = i; }
+  Void                        setNalUnitType( NalUnitType e )                        { m_eNalUnitType      = e;                                      }
+  NalUnitType                 getNalUnitType() const                                 { return m_eNalUnitType;                                        }
+  Bool                        getRapPicFlag() const;
+  Bool                        getIdrPicFlag() const                                  { return getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP; }
+  Bool                        isIRAP() const                                         { return (getNalUnitType() >= 16) && (getNalUnitType() <= 23);  }
+  Void                        checkCRA(const TComReferencePictureSet *pReferencePictureSet, Int& pocCRA, NalUnitType& associatedIRAPType, TComList<TComPic *>& rcListPic);
+  Void                        decodingRefreshMarking(Int& pocCRA, Bool& bRefreshPending, TComList<TComPic*>& rcListPic, const bool bEfficientFieldIRAPEnabled);
+  Void                        setSliceType( SliceType e )                            { m_eSliceType        = e;                                      }
+  Void                        setSliceQp( Int i )                                    { m_iSliceQp          = i;                                      }
 #if ADAPTIVE_QP_SELECTION
-  Int       getSliceQpBase  ()                          { return  m_iSliceQpBase;       }
-#endif
-  Int       getSliceQpDelta ()                          { return  m_iSliceQpDelta;      }
-  Int       getSliceQpDeltaCb ()                          { return  m_iSliceQpDeltaCb;      }
-  Int       getSliceQpDeltaCr ()                          { return  m_iSliceQpDeltaCr;      }
-  Bool      getDeblockingFilterDisable()                { return  m_deblockingFilterDisable; }
-  Bool      getDeblockingFilterOverrideFlag()           { return  m_deblockingFilterOverrideFlag; }
-  Int       getDeblockingFilterBetaOffsetDiv2()         { return  m_deblockingFilterBetaOffsetDiv2; }
-  Int       getDeblockingFilterTcOffsetDiv2()           { return  m_deblockingFilterTcOffsetDiv2; }
-
-  Int       getNumRefIdx        ( RefPicList e )                { return  m_aiNumRefIdx[e];             }
-  TComPic*  getPic              ()                              { return  m_pcPic;                      }
-  TComPic*  getRefPic           ( RefPicList e, Int iRefIdx)    { return  m_apcRefPicList[e][iRefIdx];  }
-  Int       getRefPOC           ( RefPicList e, Int iRefIdx)    { return  m_aiRefPOCList[e][iRefIdx];   }
-#if H_3D
-  Bool      getInCmpPredAvailFlag( )                             { return m_inCmpPredAvailFlag;    } 
-  Bool      getCpAvailableFlag( )                             { return m_cpAvailableFlag;    } 
-  Bool      getInCompPredFlag( )                                 { return m_inCmpPredFlag;         }    
-  Void      setInCompPredFlag( Bool b )                          { m_inCmpPredFlag = b;            }    
-  Int       getInCmpRefViewIdcs( Int i )                         { return m_inCmpRefViewIdcs  [i]; }
-  Int       getNumCurCmpLIds( )                                  { return (Int) m_inCmpRefViewIdcs.size(); } 
-  TComPic*  getIvPic            ( Bool depthFlag, Int viewIndex){ return  m_ivPicsCurrPoc[ depthFlag ? 1 : 0 ][ viewIndex ]; }
-#endif
-#if H_3D
-  TComPic*  getTexturePic       ()                              { return  m_ivPicsCurrPoc[0][ m_viewIndex ]; }
-#endif
-#if H_3D_IC
-  Void      setApplyIC( Bool b )                                { m_bApplyIC = b; }
-  Bool      getApplyIC()                                        { return m_bApplyIC; }
-  Void      xSetApplyIC();
-  Void      xSetApplyIC(Bool bUseLowLatencyICEnc);
-  Void      setIcSkipParseFlag( Bool b )                        { m_icSkipParseFlag = b; }
-  Bool      getIcSkipParseFlag()                                { return m_icSkipParseFlag; }
-#endif
-#if H_3D_ARP
-  Void      setBaseViewRefPicList( TComList<TComPic*> *pListPic, Int iViewIdx )      { m_pBaseViewRefPicList[iViewIdx] = pListPic;                   }
-  Void      setARPStepNum( TComPicLists*ivPicLists );
-  TComPic*  getBaseViewRefPic    ( UInt uiPOC , Int iViewIdx )                       { return xGetRefPic( *m_pBaseViewRefPicList[iViewIdx], uiPOC ); }
-  UInt      getARPStepNum( )                                                         { return m_nARPStepNum;                                         }  
-#endif
-  Int       getDepth            ()                              { return  m_iDepth;                     }
-  UInt      getColFromL0Flag    ()                              { return  m_colFromL0Flag;              }
-  UInt      getColRefIdx        ()                              { return  m_colRefIdx;                  }
-  Void      checkColRefIdx      (UInt curSliceIdx, TComPic* pic);
-  Bool      getIsUsedAsLongTerm (Int i, Int j)                  { return m_bIsUsedAsLongTerm[i][j]; }
-  Void      setIsUsedAsLongTerm (Int i, Int j, Bool value)      { m_bIsUsedAsLongTerm[i][j] = value; }
-  Bool      getCheckLDC     ()                                  { return m_bCheckLDC; }
-  Bool      getMvdL1ZeroFlag ()                                  { return m_bLMvdL1Zero;    }
-  Int       getNumRpsCurrTempList();
-  Int       getList1IdxToList0Idx ( Int list1Idx )               { return m_list1IdxToList0Idx[list1Idx]; }
-  Void      setReferenced(Bool b)                               { m_bRefenced = b; }
-  Bool      isReferenced()                                      { return m_bRefenced; }
-  Bool      isReferenceNalu()                                   { return ((getNalUnitType() <= NAL_UNIT_RESERVED_VCL_R15) && (getNalUnitType()%2 != 0)) || ((getNalUnitType() >= NAL_UNIT_CODED_SLICE_BLA_W_LP) && (getNalUnitType() <= NAL_UNIT_RESERVED_IRAP_VCL23) ); }
-  Void      setPOC              ( Int i )                       { m_iPOC              = i; if ((getTLayer()==0) && (isReferenceNalu() && (getNalUnitType()!=NAL_UNIT_CODED_SLICE_RASL_R)&& (getNalUnitType()!=NAL_UNIT_CODED_SLICE_RADL_R))) {m_prevTid0POC=i;} }
-  Void      setNalUnitType      ( NalUnitType e )               { m_eNalUnitType      = e;      }
-  NalUnitType getNalUnitType    () const                        { return m_eNalUnitType;        }
-  Bool      getRapPicFlag       ();  
-  Bool      getIdrPicFlag       ()                              { return getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_W_RADL || getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR_N_LP; }
-  Bool      isIRAP              () const                        { return (getNalUnitType() >= 16) && (getNalUnitType() <= 23); }  
-  Void      checkCRA(TComReferencePictureSet *pReferencePictureSet, Int& pocCRA, NalUnitType& associatedIRAPType, TComList<TComPic *>& rcListPic);
-  Void      decodingRefreshMarking(Int& pocCRA, Bool& bRefreshPending, TComList<TComPic*>& rcListPic);
-  Void      setSliceType        ( SliceType e )                 { m_eSliceType        = e;      }
-  Void      setSliceQp          ( Int i )                       { m_iSliceQp          = i;      }
-#if ADAPTIVE_QP_SELECTION
-  Void      setSliceQpBase      ( Int i )                       { m_iSliceQpBase      = i;      }
-#endif
-  Void      setSliceQpDelta     ( Int i )                       { m_iSliceQpDelta     = i;      }
-  Void      setSliceQpDeltaCb   ( Int i )                       { m_iSliceQpDeltaCb   = i;      }
-  Void      setSliceQpDeltaCr   ( Int i )                       { m_iSliceQpDeltaCr   = i;      }
-  Void      setDeblockingFilterDisable( Bool b )                { m_deblockingFilterDisable= b;      }
-  Void      setDeblockingFilterOverrideFlag( Bool b )           { m_deblockingFilterOverrideFlag = b; }
-  Void      setDeblockingFilterBetaOffsetDiv2( Int i )          { m_deblockingFilterBetaOffsetDiv2 = i; }
-  Void      setDeblockingFilterTcOffsetDiv2( Int i )            { m_deblockingFilterTcOffsetDiv2 = i; }
-  
-  Void      setRefPic           ( TComPic* p, RefPicList e, Int iRefIdx ) { m_apcRefPicList[e][iRefIdx] = p; }
-  Void      setRefPOC           ( Int i, RefPicList e, Int iRefIdx ) { m_aiRefPOCList[e][iRefIdx] = i; }
-  Void      setNumRefIdx        ( RefPicList e, Int i )         { m_aiNumRefIdx[e]    = i;      }
-  Void      setPic              ( TComPic* p )                  { m_pcPic             = p;      }
-  Void      setDepth            ( Int iDepth )                  { m_iDepth            = iDepth; }
-  
-#if H_MV
-  Void      setPocBeforeReset   ( Int i )                       { m_iPOCBeforeReset = i; }
-  Int       getPocBeforeReset   ( )                             { return m_iPOCBeforeReset; }
-  Int       getRefLayerId        ( RefPicList e, Int iRefIdx)    { return  m_aiRefLayerIdList[e][iRefIdx]; }
-  Void      setRefLayerId        ( Int i, RefPicList e, Int iRefIdx ) { m_aiRefLayerIdList[e][iRefIdx] = i; }
-  Void      getTempRefPicLists   ( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1,                                     
-                                   std::vector<TComPic*> rpsCurrList[2], std::vector<Bool> usedAsLongTerm[2], Int& numPocTotalCurr, Bool checkNumPocTotalCurr = false );
-
-  Void      setRefPicList        ( std::vector<TComPic*> rpsCurrList[2], std::vector<Bool> usedAsLongTerm[2], Int numPocTotalCurr, Bool checkNumPocTotalCurr = false ); 
+  Void                        setSliceQpBase( Int i )                                { m_iSliceQpBase      = i;                                      }
+#endif
+  Void                        setSliceQpDelta( Int i )                               { m_iSliceQpDelta     = i;                                      }
+  Void                        setSliceChromaQpDelta( ComponentID compID, Int i )     { m_iSliceChromaQpDelta[compID] = isLuma(compID) ? 0 : i;       }
+  Void                        setUseChromaQpAdj( Bool b )                            { m_ChromaQpAdjEnabled = b;                                     }
+  Void                        setDeblockingFilterDisable( Bool b )                   { m_deblockingFilterDisable= b;                                 }
+  Void                        setDeblockingFilterOverrideFlag( Bool b )              { m_deblockingFilterOverrideFlag = b;                           }
+  Void                        setDeblockingFilterBetaOffsetDiv2( Int i )             { m_deblockingFilterBetaOffsetDiv2 = i;                         }
+  Void                        setDeblockingFilterTcOffsetDiv2( Int i )               { m_deblockingFilterTcOffsetDiv2 = i;                           }
+
+  Void                        setRefPic( TComPic* p, RefPicList e, Int iRefIdx )     { m_apcRefPicList[e][iRefIdx] = p;                              }
+  Void                        setRefPOC( Int i, RefPicList e, Int iRefIdx )          { m_aiRefPOCList[e][iRefIdx] = i;                               }
+  Void                        setNumRefIdx( RefPicList e, Int i )                    { m_aiNumRefIdx[e]    = i;                                      }
+  Void                        setPic( TComPic* p )                                   { m_pcPic             = p;                                      }
+  Void                        setDepth( Int iDepth )                                 { m_iDepth            = iDepth;                                 }
+#if NH_MV
+  Void                        setPocBeforeReset( Int i )                             { m_iPOCBeforeReset = i;                                        }
+  Int                         getPocBeforeReset( )                                   { return m_iPOCBeforeReset;                                     }
+  Int                         getRefLayerId( RefPicList e, Int iRefIdx)              { return  m_aiRefLayerIdList[e][iRefIdx];                       }
+  Void                        setRefLayerId( Int i, RefPicList e, Int iRefIdx )      { m_aiRefLayerIdList[e][iRefIdx] = i;                        }
+  Void                        getTempRefPicLists   ( TComList<TComPic*>& rcListPic, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1,                                     
+                                                     std::vector<TComPic*> rpsCurrList[2], BoolAry1d usedAsLongTerm[2], Int& numPocTotalCurr, Bool checkNumPocTotalCurr = false );
+                              
+  Void                        setRefPicList        ( std::vector<TComPic*> rpsCurrList[2], BoolAry1d usedAsLongTerm[2], Int numPocTotalCurr, Bool checkNumPocTotalCurr = false ); 
 #else
-  Void      setRefPicList       ( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr = false );
-#endif
-  Void      setRefPOCList       ();
-  Void      setColFromL0Flag    ( UInt colFromL0 ) { m_colFromL0Flag = colFromL0; }
-  Void      setColRefIdx        ( UInt refIdx) { m_colRefIdx = refIdx; }
-  Void      setCheckLDC         ( Bool b )                      { m_bCheckLDC = b; }
-  Void      setMvdL1ZeroFlag     ( Bool b)                       { m_bLMvdL1Zero = b; }
-
-  Bool      isIntra         ()                          { return  m_eSliceType == I_SLICE;  }
-  Bool      isInterB        ()                          { return  m_eSliceType == B_SLICE;  }
-  Bool      isInterP        ()                          { return  m_eSliceType == P_SLICE;  }
-  
-  Void      setLambdas ( const Double lambdas[3] ) { for (Int component = 0; component < 3; component++) m_lambdas[component] = lambdas[component]; }
-  const Double* getLambdas() const { return m_lambdas; }
-  
-  Void      initEqualRef();
-  Bool      isEqualRef  ( RefPicList e, Int iRefIdx1, Int iRefIdx2 )
+  Void                        setRefPicList( TComList<TComPic*>& rcListPic, Bool checkNumPocTotalCurr = false );
+#endif
+  Void                        setRefPOCList();
+  Void                        setColFromL0Flag( Bool colFromL0 )                     { m_colFromL0Flag = colFromL0;                                  }
+  Void                        setColRefIdx( UInt refIdx)                             { m_colRefIdx = refIdx;                                         }
+  Void                        setCheckLDC( Bool b )                                  { m_bCheckLDC = b;                                              }
+  Void                        setMvdL1ZeroFlag( Bool b)                              { m_bLMvdL1Zero = b;                                            }
+
+  Bool                        isIntra() const                                        { return m_eSliceType == I_SLICE;                               }
+  Bool                        isInterB() const                                       { return m_eSliceType == B_SLICE;                               }
+  Bool                        isInterP() const                                       { return m_eSliceType == P_SLICE;                               }
+
+  Void                        setLambdas( const Double lambdas[MAX_NUM_COMPONENT] )  { for (Int component = 0; component < MAX_NUM_COMPONENT; component++) m_lambdas[component] = lambdas[component]; }
+  const Double*               getLambdas() const                                     { return m_lambdas;                                             }
+
+  Void                        initEqualRef();
+  Bool                        isEqualRef( RefPicList e, Int iRefIdx1, Int iRefIdx2 )
   {
-    if (iRefIdx1 < 0 || iRefIdx2 < 0) return false;
-    return m_abEqualRef[e][iRefIdx1][iRefIdx2];
+    assert(e<NUM_REF_PIC_LIST_01);
+    if (iRefIdx1 < 0 || iRefIdx2 < 0)
+    {
+      return false;
+    }
+    else
+    {
+      return m_abEqualRef[e][iRefIdx1][iRefIdx2];
+    }
   }
-  
-  Void setEqualRef( RefPicList e, Int iRefIdx1, Int iRefIdx2, Bool b)
+
+  Void                        setEqualRef( RefPicList e, Int iRefIdx1, Int iRefIdx2, Bool b)
   {
+    assert(e<NUM_REF_PIC_LIST_01);
     m_abEqualRef[e][iRefIdx1][iRefIdx2] = m_abEqualRef[e][iRefIdx2][iRefIdx1] = b;
   }
-  
-  static Void      sortPicList         ( TComList<TComPic*>& rcListPic );
-  Void setList1IdxToList0Idx();
-
-  UInt getTLayer             ()                            { return m_uiTLayer;                      }
-  Void setTLayer             ( UInt uiTLayer )             { m_uiTLayer = uiTLayer;                  }
-#if H_MV
-  Int getTemporalId          ( )                           { return (Int) m_uiTLayer;                }
-#endif
-
-  Void setTLayerInfo( UInt uiTLayer );
-  Void decodingMarking( TComList<TComPic*>& rcListPic, Int iGOPSIze, Int& iMaxRefPicNum ); 
-  Void checkLeadingPictureRestrictions( TComList<TComPic*>& rcListPic );
-  Void applyReferencePictureSet( TComList<TComPic*>& rcListPic, TComReferencePictureSet *RPSList);
-#if H_MV
-  Void createInterLayerReferencePictureSet( TComPicLists* ivPicLists, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1 );
-  static Void markIvRefPicsAsShortTerm    ( std::vector<TComPic*> refPicSetInterLayer0, std::vector<TComPic*> refPicSetInterLayer1 );
-  static Void markCurrPic                 ( TComPic* currPic );
-  Void        printRefPicList();
-#endif
-  Bool isTemporalLayerSwitchingPoint( TComList<TComPic*>& rcListPic );
-  Bool isStepwiseTemporalLayerSwitchingPointCandidate( TComList<TComPic*>& rcListPic );
-#if ALLOW_RECOVERY_POINT_AS_RAP
-  Int       checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess = 0, Bool bUseRecoveryPoint = false);
-  Void      createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool isRAP, Int pocRandomAccess = 0, Bool bUseRecoveryPoint = false);
-#else
-  Int       checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess = 0);
-  Void      createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, TComReferencePictureSet *pReferencePictureSet, Bool isRAP);
-#endif
-
-  Void setMaxNumMergeCand               (UInt val )         { m_maxNumMergeCand = val;                    }
-  UInt getMaxNumMergeCand               ()                  { return m_maxNumMergeCand;                   }
-
-#if SETTING_NO_OUT_PIC_PRIOR
-  Void setNoOutputPriorPicsFlag              ( Bool val )         { m_noOutputPriorPicsFlag = val;                    }
-  Bool getNoOutputPriorPicsFlag              ()                   { return m_noOutputPriorPicsFlag;                   }
-
-  Void setNoRaslOutputFlag              ( Bool val )         { m_noRaslOutputFlag = val;                    }
-  Bool getNoRaslOutputFlag              ()                   { return m_noRaslOutputFlag;                   }
-
-  Void setHandleCraAsBlaFlag              ( Bool val )         { m_handleCraAsBlaFlag = val;                    }
-  Bool getHandleCraAsBlaFlag              ()                   { return m_handleCraAsBlaFlag;                   }
-#endif
-
-  Void setSliceMode                     ( UInt uiMode )     { m_sliceMode = uiMode;                     }
-  UInt getSliceMode                     ()                  { return m_sliceMode;                       }
-  Void setSliceArgument                 ( UInt uiArgument ) { m_sliceArgument = uiArgument;             }
-  UInt getSliceArgument                 ()                  { return m_sliceArgument;                   }
-  Void setSliceCurStartCUAddr           ( UInt uiAddr )     { m_sliceCurStartCUAddr = uiAddr;           }
-  UInt getSliceCurStartCUAddr           ()                  { return m_sliceCurStartCUAddr;             }
-  Void setSliceCurEndCUAddr             ( UInt uiAddr )     { m_sliceCurEndCUAddr = uiAddr;             }
-  UInt getSliceCurEndCUAddr             ()                  { return m_sliceCurEndCUAddr;               }
-  Void setSliceIdx                      ( UInt i)           { m_sliceIdx = i;                           }
-  UInt getSliceIdx                      ()                  { return  m_sliceIdx;                       }
-  Void copySliceInfo                    (TComSlice *pcSliceSrc);
-  Void setSliceSegmentMode              ( UInt uiMode )     { m_sliceSegmentMode = uiMode;              }
-  UInt getSliceSegmentMode              ()                  { return m_sliceSegmentMode;                }
-  Void setSliceSegmentArgument          ( UInt uiArgument ) { m_sliceSegmentArgument = uiArgument;      }
-  UInt getSliceSegmentArgument          ()                  { return m_sliceSegmentArgument;            }
-  Void setSliceSegmentCurStartCUAddr    ( UInt uiAddr )     { m_sliceSegmentCurStartCUAddr = uiAddr;    }
-  UInt getSliceSegmentCurStartCUAddr    ()                  { return m_sliceSegmentCurStartCUAddr;      }
-  Void setSliceSegmentCurEndCUAddr      ( UInt uiAddr )     { m_sliceSegmentCurEndCUAddr = uiAddr;      }
-  UInt getSliceSegmentCurEndCUAddr      ()                  { return m_sliceSegmentCurEndCUAddr;        }
-  Void setNextSlice                     ( Bool b )          { m_nextSlice = b;                           }
-  Bool isNextSlice                      ()                  { return m_nextSlice;                        }
-  Void setNextSliceSegment              ( Bool b )          { m_nextSliceSegment = b;                    }
-  Bool isNextSliceSegment               ()                  { return m_nextSliceSegment;                 }
-  Void setSliceBits                     ( UInt uiVal )      { m_sliceBits = uiVal;                      }
-  UInt getSliceBits                     ()                  { return m_sliceBits;                       }  
-  Void setSliceSegmentBits              ( UInt uiVal )      { m_sliceSegmentBits = uiVal;            }
-  UInt getSliceSegmentBits              ()                  { return m_sliceSegmentBits;             }
-  Void setFinalized                     ( Bool uiVal )      { m_bFinalized = uiVal;                       }
-  Bool getFinalized                     ()                  { return m_bFinalized;                        }
-  Void  setWpScaling    ( wpScalingParam  wp[2][MAX_NUM_REF][3] ) { memcpy(m_weightPredTable, wp, sizeof(wpScalingParam)*2*MAX_NUM_REF*3); }
-  Void  getWpScaling    ( RefPicList e, Int iRefIdx, wpScalingParam *&wp);
-
-  Void  resetWpScaling  ();
-  Void  initWpScaling   ();
-  inline Bool applyWP   () { return( (m_eSliceType==P_SLICE && m_pcPPS->getUseWP()) || (m_eSliceType==B_SLICE && m_pcPPS->getWPBiPred()) ); }
-
-  Void  setWpAcDcParam  ( wpACDCParam wp[3] ) { memcpy(m_weightACDCParam, wp, sizeof(wpACDCParam)*3); }
-  Void  getWpAcDcParam  ( wpACDCParam *&wp );
-  Void  initWpAcDcParam ();
-  
-  Void setTileLocationCount             ( UInt cnt )               { return m_tileByteLocation.resize(cnt);    }
-  UInt getTileLocationCount             ()                         { return (UInt) m_tileByteLocation.size();  }
-  Void setTileLocation                  ( Int idx, UInt location ) { assert (idx<m_tileByteLocation.size());
-                                                                     m_tileByteLocation[idx] = location;       }
-  Void addTileLocation                  ( UInt location )          { m_tileByteLocation.push_back(location);   }
-  UInt getTileLocation                  ( Int idx )                { return m_tileByteLocation[idx];           }
-
-  Void setTileOffstForMultES            (UInt uiOffset )      { m_uiTileOffstForMultES = uiOffset;        }
-  UInt getTileOffstForMultES            ()                    { return m_uiTileOffstForMultES;            }
-  Void allocSubstreamSizes              ( UInt uiNumSubstreams );
-  UInt* getSubstreamSizes               ()                  { return m_puiSubstreamSizes; }
-  Void  setScalingList              ( TComScalingList* scalingList ) { m_scalingList = scalingList; }
-  TComScalingList*   getScalingList ()                               { return m_scalingList; }
-  Void  setDefaultScalingList       ();
-  Bool  checkDefaultScalingList     ();
-  Void      setCabacInitFlag  ( Bool val ) { m_cabacInitFlag = val;      }  //!< set CABAC initial flag 
-  Bool      getCabacInitFlag  ()           { return m_cabacInitFlag;     }  //!< get CABAC initial flag 
-  Void      setNumEntryPointOffsets(Int val)  { m_numEntryPointOffsets = val;     }
-  Int       getNumEntryPointOffsets()         { return m_numEntryPointOffsets;    }
-  Bool      getTemporalLayerNonReferenceFlag()       { return m_temporalLayerNonReferenceFlag;}
-  Void      setTemporalLayerNonReferenceFlag(Bool x) { m_temporalLayerNonReferenceFlag = x;}
-  Void      setLFCrossSliceBoundaryFlag     ( Bool   val )    { m_LFCrossSliceBoundaryFlag = val; }
-  Bool      getLFCrossSliceBoundaryFlag     ()                { return m_LFCrossSliceBoundaryFlag;} 
-
-  Void      setEnableTMVPFlag     ( Bool   b )    { m_enableTMVPFlag = b; }
-  Bool      getEnableTMVPFlag     ()              { return m_enableTMVPFlag;}
-#if H_MV
-  Void      setAvailableForTMVPRefFlag     ( Bool   b )    { m_availableForTMVPRefFlag = b; }
-  Bool      getAvailableForTMVPRefFlag     ()              { return m_availableForTMVPRefFlag;}
-#endif
-
-#if H_MV
-  Void      setLayerId            ( Int layerId )    { m_layerId      = layerId; }
-  Int       getLayerId            ()                 { return m_layerId;    }
-  Int       getLayerIdInVps       ()                 { return getVPS()->getLayerIdInVps( m_layerId ); }; 
-  Void      setViewId             ( Int viewId )     { m_viewId = viewId;   }
-  Int       getViewId             ()                 { return m_viewId;     }
-  Void      setViewIndex          ( Int viewIndex )  { m_viewIndex = viewIndex;   }
-  Int       getViewIndex          ()                 { return m_viewIndex;     }
-#if H_3D
+
+  static Void                 sortPicList( TComList<TComPic*>& rcListPic );
+  Void                        setList1IdxToList0Idx();
+
+  UInt                        getTLayer() const                                      { return m_uiTLayer;                                            }
+  Void                        setTLayer( UInt uiTLayer )                             { m_uiTLayer = uiTLayer;                                        }
+#if NH_MV
+  Int                         getTemporalId          ( )                             { return (Int) m_uiTLayer;                                      }
+#endif
+
+  Void                        setTLayerInfo( UInt uiTLayer );
+  Void                        decodingMarking( TComList<TComPic*>& rcListPic, Int iGOPSIze, Int& iMaxRefPicNum );
+  Void                        checkLeadingPictureRestrictions( TComList<TComPic*>& rcListPic );
+  Void                        applyReferencePictureSet( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *RPSList);
+#if NH_MV
+  Void                        createInterLayerReferencePictureSet( TComPicLists* ivPicLists, std::vector<TComPic*>& refPicSetInterLayer0, std::vector<TComPic*>& refPicSetInterLayer1 );
+  static Void                 markIvRefPicsAsShortTerm    ( std::vector<TComPic*> refPicSetInterLayer0, std::vector<TComPic*> refPicSetInterLayer1 );
+  static Void                 markCurrPic                 ( TComPic* currPic );
+  Void                        printRefPicList();
+#endif
+  Bool                        isTemporalLayerSwitchingPoint( TComList<TComPic*>& rcListPic );
+  Bool                        isStepwiseTemporalLayerSwitchingPointCandidate( TComList<TComPic*>& rcListPic );
+  Int                         checkThatAllRefPicsAreAvailable( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *pReferencePictureSet, Bool printErrors, Int pocRandomAccess = 0, Bool bUseRecoveryPoint = false);
+  Void                        createExplicitReferencePictureSetFromReference( TComList<TComPic*>& rcListPic, const TComReferencePictureSet *pReferencePictureSet, Bool isRAP, Int pocRandomAccess, Bool bUseRecoveryPoint, const Bool bEfficientFieldIRAPEnabled);
+  Void                        setMaxNumMergeCand(UInt val )                          { m_maxNumMergeCand = val;                                      }
+  UInt                        getMaxNumMergeCand() const                             { return m_maxNumMergeCand;                                     }
+
+  Void                        setNoOutputPriorPicsFlag( Bool val )                   { m_noOutputPriorPicsFlag = val;                                }
+  Bool                        getNoOutputPriorPicsFlag() const                       { return m_noOutputPriorPicsFlag;                               }
+
+  Void                        setNoRaslOutputFlag( Bool val )                        { m_noRaslOutputFlag = val;                                     }
+  Bool                        getNoRaslOutputFlag() const                            { return m_noRaslOutputFlag;                                    }
+
+  Void                        setHandleCraAsBlaFlag( Bool val )                      { m_handleCraAsBlaFlag = val;                                   }
+  Bool                        getHandleCraAsBlaFlag() const                          { return m_handleCraAsBlaFlag;                                  }
+
+  Void                        setSliceMode( SliceConstraint mode )                   { m_sliceMode = mode;                                           }
+  SliceConstraint             getSliceMode() const                                   { return m_sliceMode;                                           }
+  Void                        setSliceArgument( UInt uiArgument )                    { m_sliceArgument = uiArgument;                                 }
+  UInt                        getSliceArgument() const                               { return m_sliceArgument;                                       }
+  Void                        setSliceCurStartCtuTsAddr( UInt ctuTsAddr )            { m_sliceCurStartCtuTsAddr = ctuTsAddr;                         } // CTU Tile-scan address (as opposed to raster-scan)
+  UInt                        getSliceCurStartCtuTsAddr() const                      { return m_sliceCurStartCtuTsAddr;                              } // CTU Tile-scan address (as opposed to raster-scan)
+  Void                        setSliceCurEndCtuTsAddr( UInt ctuTsAddr )              { m_sliceCurEndCtuTsAddr = ctuTsAddr;                           } // CTU Tile-scan address (as opposed to raster-scan)
+  UInt                        getSliceCurEndCtuTsAddr() const                        { return m_sliceCurEndCtuTsAddr;                                } // CTU Tile-scan address (as opposed to raster-scan)
+  Void                        setSliceIdx( UInt i)                                   { m_sliceIdx = i;                                               }
+  UInt                        getSliceIdx() const                                    { return  m_sliceIdx;                                           }
+  Void                        copySliceInfo(TComSlice *pcSliceSrc);
+  Void                        setSliceSegmentMode( SliceConstraint mode )            { m_sliceSegmentMode = mode;                                    }
+  SliceConstraint             getSliceSegmentMode() const                            { return m_sliceSegmentMode;                                    }
+  Void                        setSliceSegmentArgument( UInt uiArgument )             { m_sliceSegmentArgument = uiArgument;                          }
+  UInt                        getSliceSegmentArgument() const                        { return m_sliceSegmentArgument;                                }
+  Void                        setSliceSegmentCurStartCtuTsAddr( UInt ctuTsAddr )     { m_sliceSegmentCurStartCtuTsAddr = ctuTsAddr;                  } // CTU Tile-scan address (as opposed to raster-scan)
+  UInt                        getSliceSegmentCurStartCtuTsAddr() const               { return m_sliceSegmentCurStartCtuTsAddr;                       } // CTU Tile-scan address (as opposed to raster-scan)
+  Void                        setSliceSegmentCurEndCtuTsAddr( UInt ctuTsAddr )       { m_sliceSegmentCurEndCtuTsAddr = ctuTsAddr;                    } // CTU Tile-scan address (as opposed to raster-scan)
+  UInt                        getSliceSegmentCurEndCtuTsAddr() const                 { return m_sliceSegmentCurEndCtuTsAddr;                         } // CTU Tile-scan address (as opposed to raster-scan)
+  Void                        setSliceBits( UInt uiVal )                             { m_sliceBits = uiVal;                                          }
+  UInt                        getSliceBits() const                                   { return m_sliceBits;                                           }
+  Void                        setSliceSegmentBits( UInt uiVal )                      { m_sliceSegmentBits = uiVal;                                   }
+  UInt                        getSliceSegmentBits() const                            { return m_sliceSegmentBits;                                    }
+  Void                        setFinalized( Bool uiVal )                             { m_bFinalized = uiVal;                                         }
+  Bool                        getFinalized() const                                   { return m_bFinalized;                                          }
+  Bool                        testWeightPred( ) const                                { return m_bTestWeightPred;                                     }
+  Void                        setTestWeightPred( Bool bValue )                       { m_bTestWeightPred = bValue;                                   }
+  Bool                        testWeightBiPred( ) const                              { return m_bTestWeightBiPred;                                   }
+  Void                        setTestWeightBiPred( Bool bValue )                     { m_bTestWeightBiPred = bValue;                                 }
+  Void                        setWpScaling( WPScalingParam  wp[NUM_REF_PIC_LIST_01][MAX_NUM_REF][MAX_NUM_COMPONENT] )
+  {
+    memcpy(m_weightPredTable, wp, sizeof(WPScalingParam)*NUM_REF_PIC_LIST_01*MAX_NUM_REF*MAX_NUM_COMPONENT);
+  }
+
+  Void                        getWpScaling( RefPicList e, Int iRefIdx, WPScalingParam *&wp);
+
+  Void                        resetWpScaling();
+  Void                        initWpScaling(const TComSPS *sps);
+
+  Void                        setWpAcDcParam( WPACDCParam wp[MAX_NUM_COMPONENT] )
+  {
+    memcpy(m_weightACDCParam, wp, sizeof(WPACDCParam)*MAX_NUM_COMPONENT);
+  }
+
+  Void                        getWpAcDcParam( WPACDCParam *&wp );
+  Void                        initWpAcDcParam();
+
+  Void                        clearSubstreamSizes( )                                 { return m_substreamSizes.clear();                              }
+  UInt                        getNumberOfSubstreamSizes( )                           { return (UInt) m_substreamSizes.size();                        }
+  Void                        addSubstreamSize( UInt size )                          { m_substreamSizes.push_back(size);                             }
+  UInt                        getSubstreamSize( Int idx )                            { assert(idx<getNumberOfSubstreamSizes()); return m_substreamSizes[idx]; }
+
+  Void                        setCabacInitFlag( Bool val )                           { m_cabacInitFlag = val;                                        } //!< set CABAC initial flag
+  Bool                        getCabacInitFlag()                                     { return m_cabacInitFlag;                                       } //!< get CABAC initial flag
+  Bool                        getTemporalLayerNonReferenceFlag()                     { return m_temporalLayerNonReferenceFlag;                       }
+  Void                        setTemporalLayerNonReferenceFlag(Bool x)               { m_temporalLayerNonReferenceFlag = x;                          }
+  Void                        setLFCrossSliceBoundaryFlag( Bool   val )              { m_LFCrossSliceBoundaryFlag = val;                             }
+  Bool                        getLFCrossSliceBoundaryFlag()                          { return m_LFCrossSliceBoundaryFlag;                            }
+
+  Void                        setEnableTMVPFlag( Bool   b )                          { m_enableTMVPFlag = b;                                         }
+  Bool                        getEnableTMVPFlag()                                    { return m_enableTMVPFlag;                                      }
+
+  Void                        setEncCABACTableIdx( SliceType idx )                   { m_encCABACTableIdx = idx;                                     }
+  SliceType                   getEncCABACTableIdx() const                            { return m_encCABACTableIdx;                                    }
+
+#if NH_MV
+  Void                        setAvailableForTMVPRefFlag( Bool   b )                 { m_availableForTMVPRefFlag = b;                                }
+  Bool                        getAvailableForTMVPRefFlag()                           { return m_availableForTMVPRefFlag;                             }
+
+  Void                        setLayerId     ( Int layerId )                         { m_layerId      = layerId;                                     }
+  Int                         getLayerId     ()                 const                { return m_layerId;                                             }
+  Int                         getLayerIdInVps()                 const                { return getVPS()->getLayerIdInVps( m_layerId );                }
+  Void                        setViewId      ( Int viewId )                          { m_viewId = viewId;                                            }
+  Int                         getViewId      ()                 const                { return m_viewId;                                              }
+  Void                        setViewIndex   ( Int viewIndex )                       { m_viewIndex = viewIndex;                                      }
+  Int                         getViewIndex   ()                 const                { return m_viewIndex;                                           }
+#if NH_3D
 #if H_3D_TMVP
-  Void      generateAlterRefforTMVP ();   
-  Void      setAlterRefIdx          ( RefPicList e, Int i ) { m_aiAlterRefIdx[e]    = i;      }
-  Int       getAlterRefIdx          ( RefPicList e )        { return  m_aiAlterRefIdx[e];     }
-#endif
-#if H_3D_ARP
-  Int       getFirstTRefIdx        ( RefPicList e )                { return  m_aiFirstTRefIdx[e];     }
-  Void      setFirstTRefIdx        ( RefPicList e, Int i )         { m_aiFirstTRefIdx[e]    = i;      }
-  Bool      getArpRefPicAvailable( RefPicList e, Int viewIdx) {return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, 0)]; }
-  std::vector<Int> getPocsInCurrRPSs()                             { return m_pocsInCurrRPSs; }; 
-#endif
-  Void      setIsDepth            ( Bool isDepth )   { m_isDepth = isDepth; }
-  Bool      getIsDepth            ()                 { return m_isDepth; }
-  Void      setCamparaSlice       ( Int** aaiScale = 0, Int** aaiOffset = 0 );
-  Int*      getCodedScale         ()  { return m_aaiCodedScale [0]; }
-  Int*      getCodedOffset        ()  { return m_aaiCodedOffset[0]; }
-  Int*      getInvCodedScale      ()  { return m_aaiCodedScale [1]; }
-  Int*      getInvCodedOffset     ()  { return m_aaiCodedOffset[1]; }
-  Void      setCpScale( Int j, Int  val ) { m_aaiCodedScale[0][j] = val; } 
-  Int       getCpScale( Int j ) { return m_aaiCodedScale[0][j]; } 
-            
-  Void      setCpOff( Int j, Int  val ) { m_aaiCodedOffset[0][j] = val; } 
-  Int       getCpOff( Int j ) { return m_aaiCodedOffset[0][j]; } 
-            
-  Void      setCpInvScale( Int j, Int  val ) { m_aaiCodedScale[1][j] = val; } 
-  Int       getCpInvScale( Int j ) { return m_aaiCodedScale[1][j]; } 
-            
-  Void      setCpInvOff( Int j, Int  val ) { m_aaiCodedOffset[1][j] = val; } 
-  Int       getCpInvOff( Int j ) { return m_aaiCodedOffset[1][j]; } 
-
-#endif
-#endif
-#if H_3D
-  Void    setIvPicLists( TComPicLists* m_ivPicLists );
-  Void    setDepthToDisparityLUTs();
-
-  Int* getDepthToDisparityB( Int refViewIdx ) { return m_depthToDisparityB[ getVPS()->getVoiInVps( refViewIdx) ]; }; 
-  Int* getDepthToDisparityF( Int refViewIdx ) { return m_depthToDisparityF[ getVPS()->getVoiInVps( refViewIdx) ]; }; 
-#endif
-#if H_3D_IC
-  Void    setICEnableCandidate( Int* ICEnableCandidate)   { m_aICEnableCandidate = ICEnableCandidate; };
-  Void    setICEnableNum( Int* ICEnableNum)   { m_aICEnableNum = ICEnableNum; };
-  Void    setICEnableCandidate( UInt layer, Int value)   { m_aICEnableCandidate[ layer ] = value; };
-  Void    setICEnableNum( UInt layer, Int value)   { m_aICEnableNum[ layer ] = value; };
-
-  Int    getICEnableCandidate( Int layer){ return  m_aICEnableCandidate[ layer ]; }; 
-  Int    getICEnableNum( Int layer){ return m_aICEnableNum[ layer ]; }; 
-#endif
-#if H_MV
+  Void                        generateAlterRefforTMVP ();   
+  Void                        setAlterRefIdx          ( RefPicList e, Int i )        { m_aiAlterRefIdx[e]    = i;                                    }
+  Int                         getAlterRefIdx          ( RefPicList e )               { return  m_aiAlterRefIdx[e];                                   }
+#endif                                                                                                                                               
+#if H_3D_ARP                                                                                                                                         
+  Int                         getFirstTRefIdx        ( RefPicList e )                { return  m_aiFirstTRefIdx[e];                                  }
+  Void                        setFirstTRefIdx        ( RefPicList e, Int i )         { m_aiFirstTRefIdx[e]    = i;                                   }
+  Bool                        getArpRefPicAvailable  ( RefPicList e, Int viewIdx)    { return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, 0)]; }
+  IntAry1d                    getPocsInCurrRPSs()                                    { return m_pocsInCurrRPSs;                                      } 
+#endif                                                                                                                                               
+  Void                        setIsDepth            ( Bool isDepth )                 { m_isDepth = isDepth;                                          }
+  Bool                        getIsDepth            () const                         { return m_isDepth;                                             }
+  Void                        setCamparaSlice       ( Int** aaiScale = 0, Int** aaiOffset = 0 );      
+
+  IntAry1d                    getCodedScale         ()                               { return m_aaiCodedScale [0];                                   }
+  IntAry1d                    getCodedOffset        ()                               { return m_aaiCodedOffset[0];                                   }
+  IntAry1d                    getInvCodedScale      ()                               { return m_aaiCodedScale [1];                                   }
+  IntAry1d                    getInvCodedOffset     ()                               { return m_aaiCodedOffset[1];                                   }
+                                                                                                                                                     
+  Void                        setCpScale( Int j, Int  val )                          { m_aaiCodedScale[0][j] = val;                                  }
+  Int                         getCpScale( Int j )                                    { return m_aaiCodedScale[0][j];                                 }
+                                                                                                                                                     
+  Void                        setCpOff( Int j, Int  val )                            { m_aaiCodedOffset[0][j] = val;                                 }
+  Int                         getCpOff( Int j )                                      { return m_aaiCodedOffset[0][j];                                }
+                                                                                                                                                     
+  Void                        setCpInvScale( Int j, Int  val )                       { m_aaiCodedScale[1][j] = val;                                  }
+  Int                         getCpInvScale( Int j )                                 { return m_aaiCodedScale[1][j];                                 }
+                                                                                                                                                     
+  Void                        setCpInvOff( Int j, Int  val )                         { m_aaiCodedOffset[1][j] = val;                                 }
+  Int                         getCpInvOff( Int j )                                   { return m_aaiCodedOffset[1][j];                                }
+                                                                                                                                                        
+  Void                        setIvPicLists( TComPicLists* m_ivPicLists );                                                                              
+  Void                        setDepthToDisparityLUTs();                                                                                                
+                                                                                                                                                        
+  Int*                        getDepthToDisparityB( Int refViewIdx )                 { return m_depthToDisparityB[ getVPS()->getVoiInVps( refViewIdx) ];}
+  Int*                        getDepthToDisparityF( Int refViewIdx )                 { return m_depthToDisparityF[ getVPS()->getVoiInVps( refViewIdx) ];}
+#if H_3D_IC                                                                                                                                             
+  Void                        setICEnableCandidate( Int* icEnableCandidate)          { m_aICEnableCandidate = icEnableCandidate;                     }
+  Void                        setICEnableNum( Int* icEnableNum)                      { m_aICEnableNum = icEnableNum;                                 }
+  Void                        setICEnableCandidate( UInt layer, Int value)           { m_aICEnableCandidate[ layer ] = value;                        }
+  Void                        setICEnableNum( UInt layer, Int value)                 { m_aICEnableNum[ layer ] = value; ;                            }
+                                                                                                                                                     
+  Int                         getICEnableCandidate( Int layer)                       { return  m_aICEnableCandidate[ layer ];                        }
+  Int                         getICEnableNum( Int layer)                             { return m_aICEnableNum[ layer ];                               }
+#endif
+#endif
 // Additional slice header syntax elements
 
-  Void setCrossLayerBlaFlag( Bool flag ) { m_crossLayerBlaFlag = flag; } 
-  Bool getCrossLayerBlaFlag(  ) { return m_crossLayerBlaFlag; } 
-  Void checkCrossLayerBlaFlag ( );
+  Void                        setCrossLayerBlaFlag( Bool flag )                      { m_crossLayerBlaFlag = flag;                                   }
+  Bool                        getCrossLayerBlaFlag(  ) const                         { return m_crossLayerBlaFlag;                                   }
+  Void                        checkCrossLayerBlaFlag ( ) const ;
 
 #if !H_MV_HLS7_GEN
-  Void setPocResetFlag( Bool flag ) { m_pocResetFlag = flag; } 
-  Bool getPocResetFlag(  ) { return m_pocResetFlag; } 
-#endif
-
-  Void setDiscardableFlag( Bool flag ) { m_discardableFlag = flag; } 
-  Bool getDiscardableFlag(  ) { return m_discardableFlag; } 
-
-  Void setInterLayerPredEnabledFlag( Bool flag ) { m_interLayerPredEnabledFlag = flag; } 
-  Bool getInterLayerPredEnabledFlag(  ) { return m_interLayerPredEnabledFlag; } 
-
-  Void setNumInterLayerRefPicsMinus1( Int  val ) { m_numInterLayerRefPicsMinus1 = val; } 
-  Int  getNumInterLayerRefPicsMinus1(  ) { return m_numInterLayerRefPicsMinus1; } 
-
-  Void setInterLayerPredLayerIdc( Int i, Int  val ) { m_interLayerPredLayerIdc[i] = val; } 
-  Int  getInterLayerPredLayerIdc( Int i ) { return m_interLayerPredLayerIdc[i]; } 
-
-  Void setSliceSegmentHeaderExtensionLength( Int  val ) { m_sliceSegmentHeaderExtensionLength = val; } 
-  Int  getSliceSegmentHeaderExtensionLength(  ) { return m_sliceSegmentHeaderExtensionLength; } 
-
-  Void setPocResetIdc( Int  val ) { m_pocResetIdc = val; } 
-  Int  getPocResetIdc(  ) { return m_pocResetIdc; } 
-  Void checkPocResetIdc( ) { assert( !(getVPS()->getPocLsbNotPresentFlag( getLayerIdInVps() ) )  || !(getSlicePicOrderCntLsb() > 0 ) || !( getPocResetIdc() == 2) ); }  
-
-  Void setPocResetPeriodId( Int  val ) { m_pocResetPeriodId = val; } 
-  Int  getPocResetPeriodId(  ) { return m_pocResetPeriodId; } 
-
-  Void setFullPocResetFlag( Bool flag ) { m_fullPocResetFlag = flag; } 
-  Bool getFullPocResetFlag(  ) { return m_fullPocResetFlag; } 
-
-  Void setPocLsbVal( Int  val ) { m_pocLsbVal = val; } 
-  Int  getPocLsbVal(  ) { return m_pocLsbVal; } 
-  Void checkPocLsbVal( ) { assert( !(getVPS()->getPocLsbNotPresentFlag( getLayerIdInVps() ) )  || !getFullPocResetFlag() || ( getPocLsbVal() == 0 ) ); }  
-
-  Void setPocMsbValPresentFlag( Bool flag ) { m_pocMsbValPresentFlag = flag; } 
-  Bool getPocMsbValPresentFlag(  ) { return m_pocMsbValPresentFlag; } 
-
-  Void setPocMsbVal( Int  val ) { m_pocMsbVal = val; } 
-  Int  getPocMsbVal(  ) { return m_pocMsbVal; } 
-
-  Bool getCraOrBlaPicFlag() { return ( getCraPicFlag() || getBlaPicFlag() ); } 
-  Bool getPocMsbValRequiredFlag() { return ( getCraOrBlaPicFlag() && ( getVPS()->getVpsPocLsbAlignedFlag() || getVPS()->getNumDirectRefLayers( getLayerIdInVps() ) == 0 ) );  }
-
-
-  UInt getPocLsbValLen() { return getSPS()->getBitsForPOC(); }; //log2_max_pic_order_cnt_lsb_minus4 + 4  
-
-  Bool getBlaPicFlag       ()
+  Void                        setPocResetFlag( Bool flag )                           { m_pocResetFlag = flag;                                        }
+  Bool                        getPocResetFlag(  ) const                              { return m_pocResetFlag;                                        }
+#endif
+
+  Void                        setDiscardableFlag( Bool flag )                        { m_discardableFlag = flag;                                     }
+  Bool                        getDiscardableFlag(  ) const                           { return m_discardableFlag;                                     }
+
+  Void                        setInterLayerPredEnabledFlag( Bool flag )              { m_interLayerPredEnabledFlag = flag;                           }
+  Bool                        getInterLayerPredEnabledFlag(  ) const                 { return m_interLayerPredEnabledFlag;                           }
+
+  Void                        setNumInterLayerRefPicsMinus1( Int  val )              { m_numInterLayerRefPicsMinus1 = val;                           }
+  Int                         getNumInterLayerRefPicsMinus1(  ) const                { return m_numInterLayerRefPicsMinus1;                          }
+
+  Void                        setInterLayerPredLayerIdc( Int i, Int  val )           { m_interLayerPredLayerIdc[i] = val;                            }
+  Int                         getInterLayerPredLayerIdc( Int i ) const               { return m_interLayerPredLayerIdc[i];                           }
+
+  Void                        setSliceSegmentHeaderExtensionLength( Int  val )       { m_sliceSegmentHeaderExtensionLength = val;                    }
+  Int                         getSliceSegmentHeaderExtensionLength(  ) const         { return m_sliceSegmentHeaderExtensionLength;                   }
+
+  Void                        setPocResetIdc( Int  val )                             { m_pocResetIdc = val;                                          }
+  Int                         getPocResetIdc(  ) const                               { return m_pocResetIdc;                                         }
+  Void                        checkPocResetIdc( ) const                              { assert( !(getVPS()->getPocLsbNotPresentFlag( getLayerIdInVps() ) )  || !(getSlicePicOrderCntLsb() > 0 ) || !( getPocResetIdc() == 2) ); }
+
+  Void                        setPocResetPeriodId( Int  val )                        { m_pocResetPeriodId = val;                                     }
+  Int                         getPocResetPeriodId(  ) const                          { return m_pocResetPeriodId;                                    }
+
+  Void                        setFullPocResetFlag( Bool flag )                       { m_fullPocResetFlag = flag;                                    }
+  Bool                        getFullPocResetFlag(  ) const                          { return m_fullPocResetFlag;                                    }
+
+  Void                        setPocLsbVal( Int  val )                               { m_pocLsbVal = val;                                            }
+  Int                         getPocLsbVal(  )  const                                { return m_pocLsbVal;                                           }
+  Void                        checkPocLsbVal( ) const                                { assert( !(getVPS()->getPocLsbNotPresentFlag( getLayerIdInVps() ) )  || !getFullPocResetFlag() || ( getPocLsbVal() == 0 ) ); }
+
+  Void                        setPocMsbValPresentFlag( Bool flag )                   { m_pocMsbValPresentFlag = flag;                                }
+  Bool                        getPocMsbValPresentFlag(  )          const             { return m_pocMsbValPresentFlag;                                }
+
+  Void                        setPocMsbVal( Int  val )                               { m_pocMsbVal = val;                                            }
+  Int                         getPocMsbVal(  )         const                         { return m_pocMsbVal;                                           }
+
+  Bool                        getCraOrBlaPicFlag()       const                       { return ( getCraPicFlag() || getBlaPicFlag() );                }
+  Bool                        getPocMsbValRequiredFlag() const                       { return ( getCraOrBlaPicFlag() && ( getVPS()->getVpsPocLsbAlignedFlag() || getVPS()->getNumDirectRefLayers( getLayerIdInVps() ) == 0 ) );  }
+
+  UInt                        getPocLsbValLen() const                                { return getSPS()->getBitsForPOC();                             }; //log2_max_pic_order_cnt_lsb_minus4 + 4
+
+  Bool getBlaPicFlag() const
   {
     return  getNalUnitType() == NAL_UNIT_CODED_SLICE_BLA_N_LP
